#!/usr/bin/env ruby

require 'dojofind.rb'
require 'book'

page = (ARGV.shift || '0').to_i
book = Book.open(page)

book.extend DojoFind

wpos = book.wpos_load
wpos_keys_size = wpos.keys.size

book.pset_reset

trap('INT') do
  book.pset_close
  if wpos_keys_size < wpos.keys.size
    book.wpos_save(wpos)
  end
  exit
end

path_list = book.path_list_load

Thread.abort_on_exception = true

require 'socket'

gs = TCPserver.open(8000 + book.page_count)
addr = gs.addr
addr.shift
print "server is on #{addr.join(':')}\n"

while true
  Thread.start(gs.accept) do |s|
    print(s, " is accepted\n")
  catch(:exit){
    line = s.gets
    throw :exit if line.nil?
    search_string = line.chomp.downcase
    
    ret_list = {}
    path_set = book.pset_load(book.compute(wpos, search_string))
    
  # idf = Math.log(path_list.size.to_f/path_set.size.to_f)
    path_set.each do |path_index, wset|
      next if wset.nil? || wset.empty?
      ret_list[path_list[path_index]] = [
        wset.size, #* idf
        wset[0]]
    end
    
    s.write Marshal.dump(ret_list)
  }
    print(s, " is gone\n")
    s.close
  end
end
